/* $Id: mstime.c,v 1.4 2001/12/18 21:29:28 phil Exp $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H defined */

#include "snotypes.h"
#include <sys/types.h>
#include <sys/times.h>			/* appeared post-v7?! */
#include <unistd.h>			/* for _SC_CLK_TCK */
/*
 * times() is venerable (it was in v6)!!
 * use POSIX sysconf() to get hz!
 */

real_t
mstime() {
    struct tms tms;
    int hz;

    hz = sysconf(_SC_CLK_TCK);
    if (hz == -1)
	return 0.0;			/* just use 60?? */

    times(&tms);
    return(tms.tms_utime*1000.0/hz);	/* just user time? */
}
